"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

const getLatestEvent = async ({
  connection,
  eventsTableName,
  escapeId,
  escape,
  shapeEvent,
  query
}, filter) => {
  const {
    eventTypes,
    aggregateIds
  } = filter;

  const injectString = value => `${escape(value)}`;

  const queryConditions = [];

  if (eventTypes != null) {
    queryConditions.push(`\`type\` IN (${eventTypes.map(injectString)})`);
  }

  if (aggregateIds != null) {
    queryConditions.push(`\`aggregateId\` IN (${aggregateIds.map(injectString)})`);
  }

  const resultQueryCondition = queryConditions.length > 0 ? `WHERE ${queryConditions.join(' AND ')}` : '';
  const eventsTableNameAsId = escapeId(eventsTableName);
  const [rows] = await query(`SELECT * FROM ${eventsTableNameAsId} ${resultQueryCondition}
    ORDER BY \`timestamp\` DESC, \`aggregateVersion\` DESC`);

  if (rows.length === 0) {
    return null;
  }

  return shapeEvent(rows[0]);
};

var _default = getLatestEvent;
exports.default = _default;
//# sourceMappingURL=get-latest-event.js.map